'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var IterationBlock = function () {
  function IterationBlock(iterationsToDo, iteratorFunc) {
    var onDoneFunc = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

    _classCallCheck(this, IterationBlock);

    this.iterationsDone = 0;
    this.iterationsToDo = iterationsToDo;
    this.iteratorFunc = iteratorFunc;
    this.onDoneFunc = onDoneFunc;
    this.iterationSuccess = this.iterationSuccess.bind(this);
    this.iterationFailure = this.iterationFailure.bind(this);
  }

  _createClass(IterationBlock, [{
    key: 'destruct',
    value: function destruct() {
      this.iteratorFunc = null;
      this.onDoneFunc = null;
    }
  }, {
    key: 'iterate',
    value: function iterate(onDoneFunc) {
      this.error = null;
      this.iteratorIsAsync = false;
      this.onDoneFunc = onDoneFunc;

      for (this.iterationsStarted = 0; this.iterationsStarted < this.iterationsToDo; this.iterationsStarted++) {
        try {
          var result = this.iteratorFunc();

          if (result && typeof result.then === 'function') {
            // async, this.iterationSuccess, this.iterationFailure have already been bound
            result.then(this.iterationSuccess, this.iterationFailure);
          } else {
            // sync
            this.iterationSuccess();
          }
        } catch (error) {
          this.iterationFailure(error);
        }
      }
    }
  }, {
    key: 'iterationSuccess',
    value: function iterationSuccess() {
      this.iterationDone();
    }
  }, {
    key: 'iterationFailure',
    value: function iterationFailure(error) {
      this.error = error;
      this.iterationDone();
    }
  }, {
    key: 'iterationDone',
    value: function iterationDone() {
      this.iterationsDone++;
      if (this.iterationsDone === this.iterationsToDo) {
        this.onDoneFunc(this.error, this.iteratorIsAsync);
      }
    }
  }]);

  return IterationBlock;
}();

exports.default = IterationBlock;