"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getSubsequentHeapGrowths;
function getSubsequentHeapGrowths(heapDiffs) {
  var growthSeriesSets = [];
  var subsequentGrowths = [];

  heapDiffs.forEach(function (heapDiff) {
    if (heapDiff.change.size_bytes > 0) {
      subsequentGrowths.push(heapDiff);
    } else {
      if (subsequentGrowths.length > 0) {
        growthSeriesSets.push(subsequentGrowths);
      }
      subsequentGrowths = [];
    }
  });

  if (subsequentGrowths.length > 0) {
    growthSeriesSets.push(subsequentGrowths);
  }

  return getLongestItem(growthSeriesSets, []);
}

function getLongestItem(array, defaultValue) {
  return array.reduce(function (longestItem, currentItem) {
    return currentItem.length > longestItem.length ? currentItem : longestItem;
  }, defaultValue);
}